from __future__ import print_function

from sos.report.plugins import RedHatPlugin
from sos.policies.redhat import RedHatPolicy, OS_RELEASE
from sos import _sos as _
#from sos import SoSOptions
import os

# Container environment variables on systems.
ENV_CONTAINER = 'container'
ENV_HOST_SYSROOT = 'HOST'

#_opts_verify = SoSOptions(verify=True)
#_opts_all_logs = SoSOptions(all_logs=True)
#_opts_all_logs_verify = SoSOptions(all_logs=True, verify=True)

#KYLIN = "Kylin"
#KYLIN_DESC = "Kylin Linux Advanced Server"

#NOTE_SIZE = "This preset may increase report size"
#NOTE_TIME = "This preset may increase report run time"
#NOTE_SIZE_TIME = "This preset may increase report size and run time"

#Kylin_presets = {
#    KYLIN: PresetDefaults(name=KYLIN, desc=KYLIN_DESC, opts=_opts_all_logs)
#}

class KylinPolicy(RedHatPolicy):
    distro = "Kylin"
    vendor = "Kylin"
    vendor_url = "http://www.kylinos.cn"
    msg = _("""\
This command will collect diagnostic and configuration \
information from this %(distro)s system and installed \
applications.

An archive containing the collected information will be \
generated in %(tmpdir)s and may be provided to a %(vendor)s \
support representative.

Any information provided to %(vendor)s will be treated in \
accordance with the published support policies at:\n
  %(vendor_url)s

The generated archive may contain data considered sensitive \
and its content should be reviewed by the originating \
organization before being passed to any third party.

No changes will be made to system configuration.
%(vendor_text)s
""")

#    def __init__(self, sysroot=None):
#        super(KylinPolicy, self).__init__(sysroot=sysroot)
#        self.register_presets(Kylin_presets)

    def __init__(self, sysroot=None, init=None, probe_runtime=True,
                 remote_exec=None):
        super(KylinPolicy, self).__init__(sysroot=sysroot, init=init,
                                              probe_runtime=probe_runtime,
                                              remote_exec=remote_exec)

    @classmethod
    def check(cls, remote=''):
        """This method checks to see if we are running on Kylin. It returns
        True or False."""
        if remote:
            return cls.distro in remote
        return os.path.isfile('/etc/kylin-release')

    def dist_version(self):
        try:
            rr = self.package_manager.all_pkgs_by_name_regex("kylin-release*")
            pkgname = self.pkgs[rr[0]]["version"]
            if pkgname[0] == "7":
                return 7
            elif pkgname[0] == "10":
                return 10
        except Exception:
            pass
        return False

#    def probe_preset(self):
#        return self.find_preset(KYLIN)
